--[[
  * Mostly Harmless's [ Mail Return Bot ]
  * Sponsored & Supported by: Mostly Harmless (mostly-harmless-guild.com)
  * Author: Wykkyd, aka Wykkyd Gaming (wykkyd.gaming@gmail.com)
  * Special Thanks To: Zenimax Online Studios & Bethesda for The Elder Scrolls Online
]]--

mhMRB = {}
mhMRB.__index = mhMRB
mhMRB.AddonID = "mhMailReturnBot"

mhMRB.Ready, mhMRB.AddonName, mhMRB.AddonAbbrev, mhMRB.AddonVersion, mhMRB.AddonDescr = FW_RegisterFactory( 
	mhMRB.AddonID, 
	{
		AddonID = mhMRB.AddonID,
		AddonName = "[MH] Mail Return Bot",
		AddonAbbrev = "mhMRB",
		Author = "Wykkyd",
		AddonVersion = "1.14.3.2.1",
		StartUp = function()
			fwMenu.AddHeader("Mail Return Bot")
			fwMenu.AddCheckbox("Enable Mail Return Bot", nil, function() 
				return mhMailReturnBot.Enabled
			end, function(val)
				mhMailReturnBot.Enabled = val
			end)
			fw.OnUpdateCallback( "Mail Return Bot", .25, mhMRB.CheckMail )
		end,
		SavedVariables = function()
			if mhMailReturnBot == nil then mhMailReturnBot = {} end
			if mhMailReturnBot.Enabled == nil then mhMailReturnBot.Enabled = false end
		end,
	}
)

mhMRB.SavedVariables = {}

mhMRB.ReturnedMail = {}

mhMRB.CheckMail = function()
	if not mhMailReturnBot.Enabled then return end
	local numMail = GetNumMailItems()
	local lastId = nil

	for m = 1, numMail, 1 do
		lastId = GetNextMailId( lastId )
		local SenderAccount, SenderName, Subject, Icon, systemBool1, systemBool2, bool3, returnedMail, numAttachments, num2, num3, daysLeft, someNumber = GetMailItemInfo( lastId )
		if string.find(SenderAccount, "@") then
			if SenderName ~= "" and Subject ~= "" then
				if numAttachments > 0 and not returnedMail and not systemBool1 and not systemBool2 then
					if string.upper(string.sub(Subject,1,6)) == "RETURN" 
					or string.upper(string.sub(Subject,1,6)) == "BOUNCE" 
					then 
						ReturnMail( lastId ); 
						if mhMRB.ReturnedMail[lastId] == nil then
							d("Returning mail '"..Subject.."' from "..SenderName) 
							mhMRB.ReturnedMail[lastId] = lastId
						end
					end
				end
			end
		end
	end
end

local b = function( bool )
	if bool then return "true" else return "false" end
end

mhMRB.ParseMail = function()
	if not mhMailReturnBot.Enabled then return end
	local numMail = GetNumMailItems()
	local lastId = nil

	for m = 1, numMail, 1 do
		lastId = GetNextMailId( lastId )
		local SenderAccount, SenderName, Subject, Icon, bool1, bool2, bool3, bool4, numAttachments, num2, num3, daysLeft, someNumber = GetMailItemInfo( lastId )
		d("Mail: "..lastId)
		d(SenderAccount.." - "..SenderName.." - "..Subject.." - "..Icon.." - "..
			b(bool1).." - "..b(bool2).." - "..b(bool3).." - "..b(bool4).." - "..
			numAttachments.." - "..num2.." - "..num3.." - "..daysLeft.." - "..someNumber)
	end
end
